/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Preferences Toolbar 2.
 *
 * The Initial Developer of the Original Code is
 * Aaron Andersen.
 * Portions created by the Initial Developer are Copyright (C) 2___
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Aaron Andersen <aaron@xulplanet.com>
 *                 Manuel Reimer <Manuel.Reimer@gmx.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function setupPanel() {
    var types = ["check", "button", "menulist", "link", "text", "separator", "spacer", "extlist", "extcheck", "", "submenu"];

    var itemId = window.arguments[0];

    goPrefBar.dump("Editing item id: " + window.arguments[0]);

    var RDF = goPrefBar.RDF.RDFService;
    var mDatasource = goPrefBar.RDF.mDatasource;

    var RitemId = RDF.GetResource(itemId);
    var Rtype = RDF.GetResource("http://www.xulplanet.com/rdf/prefbar#type");

    var LitemType = mDatasource.GetTarget(RitemId, Rtype, true);
    var itemType = LitemType.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

    goPrefBar.dump("Item type: " + itemType);

    var i = 0;
    for(var type in types) {
        goPrefBar.dump("Checking item type: " + types[type]);
        if(types[type] == itemType) {
            goPrefBar.dump("Item type match found: " + type);
            var index = i;
        }
        i++;
    }

    goPrefBar.dump("Setting item-type index to: " + index);

    var typelist = document.getElementById("item-type");
    typelist.selectedIndex = index;
    typelist.disabled = true;

    var page = document.getElementById("item-type").selectedItem.value;

    window.frames[0].document.location.href = page;

    goPrefBar.dump("Setting frame to: " + page);

    setupFrame();

    window.sizeToContent();
}

function setupFrame()
{
	var frame = document.getElementById("content-frame");

	if(frame.docShell.busyFlags != frame.docShell.BUSY_FLAGS_NONE)
	{
		goPrefBar.dump("Frame not loaded");

		setTimeout("setupFrame()", 10);
	}
	else
	{
		goPrefBar.dump("Frame loading complete");

		window.frames[0].setupEdit()	
	}
}

function dialogAccept()
{
	goPrefBar.dump("Edit item dialog accepted");

	if(window.frames[0].verifyData())
	{
		window.frames[0].editItem();

		return true;
	}
	else
	{
		return false;
	}
}
